VST 3 Examples: Steinberg::Vst Namespace Reference
Author: Steinberg

VST 3 Examples VST 3.7 SDK for developing VST plug-in

Namespaces | Classes | Typedefs | Enumerations | Functions | Variables
Steinberg::Vst Namespace Reference

## Namespaces
namespace | Algo
namespace | Attributes
namespace | AttributesFlags
namespace | AttributesFunction
namespace | AttributesStyle
namespace | AudioHost
namespace | ChannelContext
namespace | CurveType
namespace | DataExchangeHandler
namespace | EditorHost
namespace | FunctionNameType
namespace | Helpers
namespace | InterAppAudio
namespace | LayerType
namespace | LegacyMIDICCOut
namespace | mda
namespace | MPE
namespace | MusicalCharacter
namespace | MusicalInstrument
namespace | MusicalStyle
namespace | NoteExpressionSynth
namespace | ParameterChangeTransfer
namespace | ParameterValueQueue
namespace | PlugType
namespace | PresetAttributes
namespace | PresetFile
namespace | SampleAccurate
namespace | SpeakerArr
namespace | StateType
namespace | StringConvert
namespace | Test
namespace | UMP
namespace | ViewType

## Classes
class | ADelayController
class | ADelayProcessor
class | AGain
class | AGainController
class | AGainUIMessageController
class | AGainWithSideChain
class | AudioBuffer
class | AudioBus
struct | AudioBusBuffers
class | AudioEffect
class | BufferStream
class | Bus
struct | BusInfo
class | BusList
class | BypassProcessor
struct | Chord
struct | ChordEvent
class | Component
class | ComponentBase
class | ConnectionProxy
struct | DataEvent
struct | DataExchangeBlock
class | DataExchangeHandler
class | DataExchangeReceiverHandler
class | EditController
class | EditControllerEx1
class | EditorSizeController
class | EditorView
struct | Event
class | EventBus
class | EventList
class | FileStream
struct | FrameRate
class | HostApplication
class | HostAttributeList
class | HostCheckerController
class | HostCheckerProcessor
struct | HostDataExchangeHandler
class | HostMessage
class | HostProcessData
class | IAttributeList
class | IAudioPresentationLatency
class | IAudioProcessor
class | IAutomationState
class | IComponent
class | IComponentHandler
class | IComponentHandler2
class | IComponentHandler3
class | IComponentHandlerBusActivation
class | IComponentHandlerSystemTime
class | IConnectionPoint
class | IContextMenu
struct | IContextMenuItem
class | IContextMenuTarget
class | IDataExchangeHandler
struct | IDataExchangeHandlerHost
class | IDataExchangeReceiver
class | IDelayTestController
class | IEditController
class | IEditController2
class | IEditControllerHostEditing
class | IEventList
class | IHostApplication
class | IInterAppAudioConnectionNotification
class | IInterAppAudioHost
class | IInterAppAudioPresetManager
class | IKeyswitchController
class | IMessage
class | IMidiLearn
class | IMidiMapping
class | INoteExpressionController
class | INoteExpressionPhysicalUIMapping
class | IParameterChanges
class | IParameterFinder
class | IParameterFunctionName
class | IParamValueQueue
class | IPlugInterfaceSupport
class | IPrefetchableSupport
class | IProcessContextRequirements
class | IProgramListData
class | IProgress
class | IRemapParamID
class | IStreamAttributes
class | ITestPlugProvider
class | ITestPlugProvider2
class | IUnitData
class | IUnitHandler
class | IUnitHandler2
class | IUnitInfo
class | IVst3ToAAXWrapper
class | IVst3ToAUWrapper
class | IVst3ToVst2Wrapper
class | IVst3WrapperMPESupport
class | IXmlRepresentationController
struct | KeyswitchInfo
struct | LegacyMIDICCOutEvent
class | LogScale
| LogScale class. More...
class | LogScaleParameter
| Parameter class with a LogScale. More...
struct | NoteExpressionTextEvent
class | NoteExpressionType
class | NoteExpressionTypeContainer
struct | NoteExpressionTypeInfo
struct | NoteExpressionValueDescription
struct | NoteExpressionValueEvent
struct | NoteOffEvent
struct | NoteOnEvent
class | ParamChanges
class | Parameter
class | ParameterChanges
class | ParameterChangeTransfer
class | ParameterContainer
struct | ParameterInfo
class | ParameterValueQueue
class | ParamPoint
struct | PhysicalUIMap
struct | PhysicalUIMapList
class | PitchNamesController
class | PitchNamesProcessor
class | Plug
class | PlugController
class | PluginContextFactory
class | PlugInterfaceSupport
class | PlugProvider
struct | PolyPressureEvent
class | PresetFile
struct | ProcessContext
class | ProcessContextRequirements
struct | ProcessData
class | ProcessDataSlicer
struct | ProcessSetup
class | ProgramList
struct | ProgramListInfo
class | ProgramListWithPitchNames
class | RangeNoteExpressionType
class | RangeParameter
class | ReadOnlyBStream
struct | RepresentationInfo
struct | RoutingInfo
struct | RTTransferT
struct | ScaleEvent
class | SingleComponentEffect
class | SpeakerArray
class | StringListParameter
class | StringResult
class | SyncDelayController
class | SyncDelayProcessor
struct | SyncEntry
class | SystemTime
class | TestBase
struct | TestDefaults
class | TestEnh
struct | TestingPluginContext
class | TestSuite
class | ThreadChecker
class | Unit
struct | UnitInfo
class | Validator
| Main Class of Validator. More...
class | VoiceBase
| Example Voice class for the Steinberg::Vst::VoiceProcessorImplementation. More...
class | VoiceProcessor
| A Voice Processor class. More...
class | VoiceProcessorImplementation
| A Simple Voice Processor Implementation supporting note expression events. More...
class | VSTGUIEditor
class | VstModule
| This handles the plug-in factory in its library. More...
class | XmlRepresentationHelper

## Typedefs
typedef uint32 | DataExchangeQueueID
typedef uint32 | DataExchangeBlockID
typedef uint32 | DataExchangeUserContextID
typedef int32 | KnobMode
typedef uint32 | NoteExpressionTypeID
typedef double | NoteExpressionValue
typedef uint32 | KeyswitchTypeID
typedef uint32 | PhysicalUITypeID
typedef uint32 | PrefetchableSupport
typedef char16 | TChar
typedef TChar | String128[128]
typedef const char8 * | CString
typedef int32 | MediaType
typedef int32 | BusDirection
typedef int32 | BusType
typedef int32 | IoMode
typedef int32 | UnitID
typedef double | ParamValue
typedef uint32 | ParamID
typedef int32 | ProgramListID
typedef int16 | CtrlNumber
typedef double | TQuarterNotes
typedef int64 | TSamples
typedef uint32 | ColorSpec
typedef float | Sample32
typedef double | Sample64
typedef double | SampleRate
typedef uint64 | SpeakerArrangement
typedef uint64 | Speaker
typedef char[4] | ChunkID
typedef int32 | ProcessSampleSize
typedef std::function< bool(ITestResult *)> | TestFunc
typedef std::function< bool(FUnknown *, ITestResult *)> | TestFuncWithContext
using | SizeFactors = std::vector< float >

## Enumerations
enum | ComponentFlags
enum | SymbolicSampleSizes
enum | ProcessModes
enum | MediaTypes
enum | BusDirections
enum | BusTypes
enum | IoModes
enum | RestartFlags
enum | KnobModes
enum | NoteIDUserRange
enum | ControllerNumbers
enum | NoteExpressionTypeIDs
enum | KeyswitchTypeIDs
enum | PhysicalUITypeIDs
enum | ePrefetchableSupport
enum | ChunkType
enum | { kDelayId = 100 , kBypassId = 101 }
enum | { kProcessingLoadTag = 1000 , kGeneratePeaksTag , kLatencyTag , kBypassTag , kCanResizeTag , kScoreTag , kParamWhichCouldBeHiddenTag , kTriggerHiddenTag , kTriggerProgressTag , kProgressValueTag , kCopy2ClipboardTag , kRestartNoteExpressionChangedTag , kRestartKeyswitchChangedTag , kRestartParamValuesChangedTag , kRestartParamTitlesChangedTag , kProcessContextProjectTimeSamplesTag , kProcessContextProjectTimeMusicTag , kProcessContextTempoTag , kProcessContextStateTag , kProcessContextSystemTimeTag , kProcessContextContinousTimeSamplesTag , kProcessContextTimeSigNumeratorTag , kProcessContextTimeSigDenominatorTag , kProcessContextBarPositionMusicTag , kParamLowLatencyTag , kParamRandomizeTag , kProcessWarnTag , kLastTag = kProcessWarnTag + HostChecker::kParamWarnCount , kParamUnitStructStart , kParamUnitStructEnd = kParamUnitStructStart + HostChecker::kParamUnitStructCount , kUnitId = 1234 , kUnit2Id = 1235 , kUnitParamIdStart = 2345 }
enum | { kDelayId = 100 , kBypassId = 101 }

## Functions
IMessage * | allocateMessage (IHostApplication *host)
void ** | getChannelBuffersPointer (const ProcessSetup &processSetup, const AudioBusBuffers &bufs)
uint32 | getSampleFramesSizeInBytes (const ProcessSetup &processSetup, int32 numSamples)
uint64 | getChannelMask (int32 numChannels)
tresult | getSpeakerChannelIndex (SpeakerArrangement arrangement, uint64 speaker, int32 &channel)
void | setupVSTGUIBundleSupport (void *hInstance)
const ChunkID & | getChunkID (ChunkType type)
bool | verify (tresult result)
bool | copyStream (IBStream *inStream, IBStream *outStream)
| IMPLEMENT_FUNKNOWN_METHODS (FileStream, IBStream, IBStream::iid) tresult FileStream
| IMPLEMENT_REFCOUNT (ReadOnlyBStream) ReadOnlyBStream
| IMPLEMENT_FUNKNOWN_METHODS (BufferStream, IBStream, IBStream::iid) BufferStream
bool | isEqualID (const ChunkID id1, const ChunkID id2)
| IMPLEMENT_FUNKNOWN_METHODS (ConnectionProxy, IConnectionPoint, IConnectionPoint::iid) ConnectionProxy
| IMPLEMENT_FUNKNOWN_METHODS (EventList, IEventList, IEventList::iid) EventList
| IMPLEMENT_FUNKNOWN_METHODS (HostMessage, IMessage, IMessage::iid) HostMessage
| IMPLEMENT_FUNKNOWN_METHODS (HostAttributeList, IAttributeList, IAttributeList::iid) IPtr< IAttributeList > HostAttributeList
| IMPLEMENT_FUNKNOWN_METHODS (ParameterChanges, IParameterChanges, IParameterChanges::iid) IMPLEMENT_FUNKNOWN_METHODS(ParameterValueQueue
| IMPLEMENT_FUNKNOWN_METHODS (TestBase, ITest, ITest::iid)
void | addMessage (ITestResult *testResult, const std::u16string &str)
void | addMessage (ITestResult *testResult, const char *str)
void | addErrorMessage (ITestResult *testResult, const char *str)
void | addErrorMessage (ITestResult *testResult, const std::u16string &str)
std::u16string | printf (const char8 *format,...)
| IMPLEMENT_FUNKNOWN_METHODS (ParamChanges, IParamValueQueue, IParamValueQueue::iid) ParamChanges
| SMTG_TYPE_ALIGN_CHECK (PFactoryInfo, 4, 4, 4, 4) SMTG_TYPE_ALIGN_CHECK(PClassInfo
| SMTG_TYPE_ALIGN_CHECK (PClassInfo2, 4, 4, 4, 4) SMTG_TYPE_ALIGN_CHECK(PClassInfoW
| SMTG_TYPE_ALIGN_CHECK (ProcessSetup, 8, 1, 8, 8) SMTG_TYPE_ALIGN_CHECK(AudioBusBuffers
| SMTG_TYPE_ALIGN_CHECK (ProcessData, 8, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(BusInfo
| SMTG_TYPE_ALIGN_CHECK (RoutingInfo, 4, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(IContextMenuItem
| SMTG_TYPE_ALIGN_CHECK (ParameterInfo, 8, 1, 8, 8) SMTG_TYPE_ALIGN_CHECK(NoteOnEvent
| SMTG_TYPE_ALIGN_CHECK (NoteOffEvent, 4, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(DataEvent
| SMTG_TYPE_ALIGN_CHECK (PolyPressureEvent, 4, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(ChordEvent
| SMTG_TYPE_ALIGN_CHECK (ScaleEvent, 8, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(LegacyMIDICCOutEvent
| SMTG_TYPE_ALIGN_CHECK (Event, 8, 1, 8, 8) SMTG_TYPE_ALIGN_CHECK(NoteExpressionValueDescription
| SMTG_TYPE_ALIGN_CHECK (NoteExpressionValueEvent, 8, 1, 4, 8) SMTG_TYPE_ALIGN_CHECK(NoteExpressionTextEvent
| SMTG_TYPE_ALIGN_CHECK (NoteExpressionTypeInfo, 8, 1, 8, 8) SMTG_TYPE_ALIGN_CHECK(KeyswitchInfo
| SMTG_TYPE_ALIGN_CHECK (FrameRate, 4, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(Chord
| SMTG_TYPE_ALIGN_CHECK (ProcessContext, 8, 1, 8, 8) SMTG_TYPE_ALIGN_CHECK(RepresentationInfo
| SMTG_TYPE_ALIGN_CHECK (UnitInfo, 4, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(ProgramListInfo
void | printStructSizes ()
void * | aligned_alloc (size_t numBytes, uint32_t alignment)
void | aligned_free (void *addr, uint32_t alignment)
Sample32 ** | getChannelBuffers (AudioBusBuffers &buffer)
bool | operator== (const DataExchangeHandler::Config &c1, const DataExchangeHandler::Config &c2)
bool | operator!= (const DataExchangeBlock &lhs, const DataExchangeBlock &rhs)
bool | operator== (const DataExchangeBlock &lhs, const DataExchangeBlock &rhs)
const Steinberg::Vst::TChar * | toTChar (const std::u16string &str)
std::u16string | toString (NumberT value)
FUnknown * | createTestFactoryInstance (void *)
const FUID & | getTestFactoryUID ()
void | registerTest (FIDString name, const char *desc, const TestFunc &func)
void | registerTest (FIDString name, const char *desc, TestFunc &&func)
void | registerTest (FIDString name, const char *desc, const TestFuncWithContext &func)
void | registerTest (FIDString name, const char *desc, TestFuncWithContext &&func)
void | registerTest (FIDString name, ITest *test)
| DEF_CLASS_IID (IDelayTestController) tresult ADelayController

## Variables
| kDistributable
| kSimpleModeSupported
| kSample32
| kSample64
| kRealtime
| kPrefetch
| kOffline
| kAudio
| kEvent
| kNumMediaTypes
| kInput
| kOutput
| kMain
| kAux
| kSimple
| kAdvanced
| kOfflineProcessing
| kReloadComponent
| kIoChanged
| kParamValuesChanged
| kLatencyChanged
| kParamTitlesChanged
| kMidiCCAssignmentChanged
| kNoteExpressionChanged
| kIoTitlesChanged
| kPrefetchableSupportChanged
| kRoutingInfoChanged
| kKeyswitchChanged
| kParamIDMappingChanged
| kCircularMode
| kRelativCircularMode
| kLinearMode
| kNoteIDUserRangeLowerBound
| kNoteIDUserRangeUpperBound
| kCtrlBankSelectMSB
| kCtrlModWheel
| kCtrlBreath
| kCtrlFoot
| kCtrlPortaTime
| kCtrlDataEntryMSB
| kCtrlVolume
| kCtrlBalance
| kCtrlPan
| kCtrlExpression
| kCtrlEffect1
| kCtrlEffect2
| kCtrlGPC1
| kCtrlGPC2
| kCtrlGPC3
| kCtrlGPC4
| kCtrlBankSelectLSB
| kCtrlDataEntryLSB
| kCtrlSustainOnOff
| kCtrlPortaOnOff
| kCtrlSustenutoOnOff
| kCtrlSoftPedalOnOff
| kCtrlLegatoFootSwOnOff
| kCtrlHold2OnOff
| kCtrlSoundVariation
| kCtrlFilterCutoff
| kCtrlReleaseTime
| kCtrlAttackTime
| kCtrlFilterResonance
| kCtrlDecayTime
| kCtrlVibratoRate
| kCtrlVibratoDepth
| kCtrlVibratoDelay
| kCtrlSoundCtrler10
| kCtrlGPC5
| kCtrlGPC6
| kCtrlGPC7
| kCtrlGPC8
| kCtrlPortaControl
| kCtrlEff1Depth
| kCtrlEff2Depth
| kCtrlEff3Depth
| kCtrlEff4Depth
| kCtrlEff5Depth
| kCtrlDataIncrement
| kCtrlDataDecrement
| kCtrlNRPNSelectLSB
| kCtrlNRPNSelectMSB
| kCtrlRPNSelectLSB
| kCtrlRPNSelectMSB
| kCtrlAllSoundsOff
| kCtrlResetAllCtrlers
| kCtrlLocalCtrlOnOff
| kCtrlAllNotesOff
| kCtrlOmniModeOff
| kCtrlOmniModeOn
| kCtrlPolyModeOnOff
| kCtrlPolyModeOn
| kAfterTouch
| kPitchBend
| kCountCtrlNumber
| kCtrlProgramChange
| kCtrlPolyPressure
| kCtrlQuarterFrame
| kVolumeTypeID
| kPanTypeID
| kTuningTypeID
| kVibratoTypeID
| kExpressionTypeID
| kBrightnessTypeID
| kTextTypeID
| kPhonemeTypeID
| kCustomStart
| kCustomEnd
| kInvalidTypeID
| kNoteOnKeyswitchTypeID
| kOnTheFlyKeyswitchTypeID
| kOnReleaseKeyswitchTypeID
| kKeyRangeTypeID
| kPUIXMovement
| kPUIYMovement
| kPUIPressure
| kPUITypeCount
| kInvalidPUITypeID
| kIsNeverPrefetchable
| kIsYetPrefetchable
| kIsNotYetPrefetchable
| kNumPrefetchableSupport
const int32 | kDefaultFactoryFlags
const Speaker | kSpeakerL
const Speaker | kSpeakerR
const Speaker | kSpeakerC
const Speaker | kSpeakerLfe
const Speaker | kSpeakerLs
const Speaker | kSpeakerRs
const Speaker | kSpeakerLc
const Speaker | kSpeakerRc
const Speaker | kSpeakerS
const Speaker | kSpeakerCs
const Speaker | kSpeakerSl
const Speaker | kSpeakerSr
const Speaker | kSpeakerTc
const Speaker | kSpeakerTfl
const Speaker | kSpeakerTfc
const Speaker | kSpeakerTfr
const Speaker | kSpeakerTrl
const Speaker | kSpeakerTrc
const Speaker | kSpeakerTrr
const Speaker | kSpeakerLfe2
const Speaker | kSpeakerM
const Speaker | kSpeakerACN0
const Speaker | kSpeakerACN1
const Speaker | kSpeakerACN2
const Speaker | kSpeakerACN3
const Speaker | kSpeakerACN4
const Speaker | kSpeakerACN5
const Speaker | kSpeakerACN6
const Speaker | kSpeakerACN7
const Speaker | kSpeakerACN8
const Speaker | kSpeakerACN9
const Speaker | kSpeakerACN10
const Speaker | kSpeakerACN11
const Speaker | kSpeakerACN12
const Speaker | kSpeakerACN13
const Speaker | kSpeakerACN14
const Speaker | kSpeakerACN15
const Speaker | kSpeakerACN16
const Speaker | kSpeakerACN17
const Speaker | kSpeakerACN18
const Speaker | kSpeakerACN19
const Speaker | kSpeakerACN20
const Speaker | kSpeakerACN21
const Speaker | kSpeakerACN22
const Speaker | kSpeakerACN23
const Speaker | kSpeakerACN24
const Speaker | kSpeakerTsl
const Speaker | kSpeakerTsr
const Speaker | kSpeakerLcs
const Speaker | kSpeakerRcs
const Speaker | kSpeakerBfl
const Speaker | kSpeakerBfc
const Speaker | kSpeakerBfr
const Speaker | kSpeakerPl
const Speaker | kSpeakerPr
const Speaker | kSpeakerBsl
const Speaker | kSpeakerBsr
const Speaker | kSpeakerBrl
const Speaker | kSpeakerBrc
const Speaker | kSpeakerBrr
const Speaker | kSpeakerLw
const Speaker | kSpeakerRw
| kHeader
| kComponentState
| kControllerState
| kProgramData
| kMetaInfo
| kChunkList
| kNumPresetChunks
| IParamValueQueue
IParamValueQueue::iid constexpr int32 | kQueueReservedPoints
bool | THREAD_CHECK_EXIT = false

## Typedef Documentation

## ◆ SizeFactors

using SizeFactors = std::vector<float>

## Enumeration Type Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
kDelayId |
kBypassId |

## ◆ anonymous enum

anonymous enum

Enumerator
kProcessingLoadTag |
kGeneratePeaksTag |
kLatencyTag |
kBypassTag |
kCanResizeTag |
kScoreTag |
kParamWhichCouldBeHiddenTag |
kTriggerHiddenTag |
kTriggerProgressTag |
kProgressValueTag |
kCopy2ClipboardTag |
kRestartNoteExpressionChangedTag |
kRestartKeyswitchChangedTag |
kRestartParamValuesChangedTag |
kRestartParamTitlesChangedTag |
kProcessContextProjectTimeSamplesTag |
kProcessContextProjectTimeMusicTag |
kProcessContextTempoTag |
kProcessContextStateTag |
kProcessContextSystemTimeTag |
kProcessContextContinousTimeSamplesTag |
kProcessContextTimeSigNumeratorTag |
kProcessContextTimeSigDenominatorTag |
kProcessContextBarPositionMusicTag |
kParamLowLatencyTag |
kParamRandomizeTag |
kProcessWarnTag |
kLastTag |
kParamUnitStructStart |
kParamUnitStructEnd |
kUnitId |
kUnit2Id |
kUnitParamIdStart |

## ◆ anonymous enum

anonymous enum

Enumerator
kDelayId |
kBypassId |

## Function Documentation

## ◆ DEF_CLASS_IID()

Steinberg::Vst::DEF_CLASS_IID | ( | IDelayTestController |  | ) |

## Variable Documentation

## ◆ THREAD_CHECK_EXIT

bool THREAD_CHECK_EXIT = false

Empty

Copyright © Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.